/**
 * Assignment #7: Disk Scheduling Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#ifndef C_LOOK_R_H_
#define C_LOOK_R_H_

#include <vector>
#include <algorithm>
#include "SchedulingAlgorithm.h"

using namespace std;

class C_LOOK_R : public SchedulingAlgorithm
{
public:
    C_LOOK_R(const int max_cylinder) : SchedulingAlgorithm("C-LOOK-R", max_cylinder) {}

    void move(vector<int> requests)
    {
        vector<int> left;
        vector<int> right;

        int starting = movement[0];

        for (int cylinder : requests)
        {
            if (cylinder <= starting)  left.push_back(cylinder);
            else                      right.push_back(cylinder);
        }

        std::sort(left.begin(),  left.end());
        std::sort(right.begin(), right.end());

        for (auto it = right.begin(); it != right.end(); it++) movement.push_back(*it);
        for (auto it = left.begin(); it != left.end(); it++) movement.push_back(*it);
    }
};

#endif /* C_LOOK_R_H_ */
