/**
 * Assignment #7: Disk Scheduling Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#ifndef C_SCAN_L_H_
#define C_SCAN_L_H_

#include <vector>
#include <algorithm>
#include "SchedulingAlgorithm.h"

using namespace std;

class C_SCAN_L : public SchedulingAlgorithm
{
public:
    C_SCAN_L(const int max_cylinder) : SchedulingAlgorithm("C-SCAN-L", max_cylinder) {}

    void move(vector<int> requests)
    {
        vector<int> left;
        vector<int> right;

        int starting = movement[0];

        for (int cylinder : requests)
        {
            if (cylinder <= starting)  left.push_back(cylinder);
            else                      right.push_back(cylinder);
        }

        std::sort(left.begin(),  left.end());
        std::sort(right.begin(), right.end());

        // Reverse iterators.
        for (auto it = left.rbegin(); it != left.rend(); it++) movement.push_back(*it);
        movement.push_back(0);
        movement.push_back(max_cylinder);
        for (auto it = right.rbegin(); it != right.rend(); it++) movement.push_back(*it);
    }
};

#endif /* C_SCAN_L_H_ */
