/**
 * Assignment #7: Disk Scheduling Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#ifndef LOOKL_L_H_
#define LOOKL_L_H_

#include <vector>
#include <algorithm>
#include "SchedulingAlgorithm.h"

using namespace std;

class LOOK_L : public SchedulingAlgorithm
{
public:
    LOOK_L(const int max_cylinder) : SchedulingAlgorithm("LOOK-L", max_cylinder) {}

    void move(vector<int> requests)
    {
        vector<int> left;
        vector<int> right;

        int starting = movement[0];

        for (int cylinder : requests)
        {
            if (cylinder <= starting)  left.push_back(cylinder);
            else                      right.push_back(cylinder);
        }

        std::sort(left.begin(),  left.end());
        std::sort(right.begin(), right.end());

        // Reverse iterator.
        for (auto it = left.rbegin(); it != left.rend(); it++) movement.push_back(*it);

        for (auto it = right.begin(); it != right.end(); it++) movement.push_back(*it);
    }
};

#endif /* LOOKL_L_H_ */
