/**
 * Assignment #7: Disk Scheduling Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#ifndef SSTF_H_
#define SSTF_H_

#include <vector>
#include "SchedulingAlgorithm.h"

using namespace std;

class SSTF : public SchedulingAlgorithm
{
public:
    SSTF(const int max_cylinder) : SchedulingAlgorithm("SSTF", max_cylinder) {}

    void move(vector<int> requests)
    {
        int prev = movement[0];

        while (requests.size() > 0)
        {
            int min_seek  = abs(requests[0] - prev);
            int min_index = 0;

            for (int i = 0; i < requests.size(); i++)
            {
                int seek = abs(requests[i] - prev);

                if (seek < min_seek)
                {
                    min_seek  = seek;
                    min_index = i;
                }
            }

            prev = requests[min_index];
            movement.push_back(prev);
            requests.erase(requests.begin() + min_index);
        }
    }
};

#endif /* SSTF_H_ */


