/**
 * Assignment #7: Disk Scheduling Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#include <vector>

#include "SchedulingAlgorithm.h"
#include "Grapher.h"
#include "FCFS.h"
#include "SSTF.h"
#include "SCAN-L.h"
#include "SCAN-R.h"
#include "LOOK-L.h"
#include "LOOK-R.h"
#include "C-SCAN-L.h"
#include "C-SCAN-R.h"
#include "C-LOOK-L.h"
#include "C-LOOK-R.h"

//#define BOOK

using namespace std;

#ifdef BOOK
    #define MAX_CYLINDER      199
    #define STARTING_CYLINDER  53
#else
    #define MAX_CYLINDER      4999
    #define STARTING_CYLINDER 2255
#endif

int main()
{
#ifdef BOOK
    vector<int> requests = { 98, 183, 37, 122, 14, 124, 65, 67 };
#else
    vector<int> requests = { 2055, 1175, 2304, 2700, 513,
                             1680,  256, 1401, 4922, 3692 };
#endif

    FCFS fcfs(MAX_CYLINDER);
    fcfs.schedule(requests, STARTING_CYLINDER);

    SSTF sstf(MAX_CYLINDER);
    sstf.schedule(requests, STARTING_CYLINDER);

    SCAN_L scan_l(MAX_CYLINDER);
    scan_l.schedule(requests, STARTING_CYLINDER);

    SCAN_R scan_r(MAX_CYLINDER);
    scan_r.schedule(requests, STARTING_CYLINDER);

    LOOK_L look_l(MAX_CYLINDER);
    look_l.schedule(requests, STARTING_CYLINDER);

    LOOK_R look_r(MAX_CYLINDER);
    look_r.schedule(requests, STARTING_CYLINDER);

    C_SCAN_L c_scan_l(MAX_CYLINDER);
    c_scan_l.schedule(requests, STARTING_CYLINDER);

    C_SCAN_R c_scan(MAX_CYLINDER);
    c_scan.schedule(requests, STARTING_CYLINDER);

    C_LOOK_L c_look_l(MAX_CYLINDER);
    c_look_l.schedule(requests, STARTING_CYLINDER);

    C_LOOK_R c_look_r(MAX_CYLINDER);
    c_look_r.schedule(requests, STARTING_CYLINDER);

    return 0;
}
